<template>
  <v-expansion-panel>
    <v-expansion-panel-header :disable-icon-rotate="!!bug.message || !!bug.error">
      {{ bug.title }}
      <template v-if="bug.message || bug.error" #actions>
        <v-icon v-if="!!bug.message" color="success">done</v-icon>
        <v-icon v-else color="error">error</v-icon>
      </template>
    </v-expansion-panel-header>
    <v-expansion-panel-content>
      <template v-if="bug.message || bug.error">
        <br>
        <v-expansion-panels focusable>
          <v-expansion-panel v-if="bug.message">
            <v-expansion-panel-header>
              Сообщение об успехе
            </v-expansion-panel-header>
            <v-expansion-panel-content>
              <v-card-text>
                <span v-html="bug.message"/>
              </v-card-text>
            </v-expansion-panel-content>
          </v-expansion-panel>
          <v-expansion-panel v-if="bug.error">
            <v-expansion-panel-header>
              Сообщение об ошибке
            </v-expansion-panel-header>
            <v-expansion-panel-content>
              <v-card-text>
                <span v-html="bug.error"/>
              </v-card-text>
            </v-expansion-panel-content>
          </v-expansion-panel>
        </v-expansion-panels>
      </template>
      <v-card-subtitle>
        <div v-html="bug.description"/>
      </v-card-subtitle>
      <v-card-actions>
        <v-btn v-bind="getButtonAttributes()" @click="getBugFunction()()">
          <template v-if="!bug.button || !bug.button.title">
            Протестировать
          </template>
          <template v-else>
            {{ bug.button.title }}
          </template>
        </v-btn>
        <v-btn v-if="bug.resolved && bug.testOfFixAvailable" v-bind="getButtonAttributes(false, 'success')"
               @click="testBugFix()">
          Протестировать фикс
        </v-btn>
      </v-card-actions>
    </v-expansion-panel-content>
  </v-expansion-panel>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { BugArray } from '~/types';
import { serializeError } from 'serialize-error';

export default Vue.extend({
  name: 'Bug',
  props: {
    bug: {
      type: Object,
      required: true,
    } as PropOptions<BugArray>,
    loading: {
      type: Boolean,
      required: true,
    },
  },
  methods: {
    getButtonAttributes(includeButtonProperty = true, color: string = 'primary'): { [key: string]: any } {
      let attributes = {
        disabled: this.loading,
        loading: this.loading,
        color,
        small: true,
      };

      if (includeButtonProperty) attributes = {
        ...attributes,
        ...(typeof this.bug.button?.attributes === 'object' ? this.bug.button.attributes : this.getBugAttributes()),
      };

      return attributes;
    },
    getBugAttributes(): { [key: string]: any } {
      if (this.bug.type === this.bugsTypes.AndroidDownload) return {
        href: require('./../api/assets/story.png'),
        download: 'test.png',
      };

      return {};
    },
    getBugFunction(): () => any {
      if (this.bug.button?.action) {
        if (typeof this.bug.button.action === 'function') return this.bug.button.action;
        if (this.bug.type === this.bugsTypes.AndroidDownload) return () => {
          delete this.bug.error;
          this.bug.message = 'Надо проверить, скачался ли файл';
          this.$forceUpdate();
        };

        return () => {
        };
      }

      return this.testBug;
    },
    async testBug() {
      delete this.bug.message;
      delete this.bug.error;
      this.$emit('loading', true);
      try {
        switch (this.bug.type) {
          case this.bugsTypes.StoryUpload :
            await this.testStoryUpload();
            break;
          case this.bugsTypes.SSRTokenGet:
            this.$router.replace(`/ssr-token-get`);
            return;
          case this.bugsTypes.ShareResultString:
            await this.testWallShare();
            break;
          case this.bugsTypes.StorySave:
            const result = await this.$wnm.vkStories('classic', {
              type: 'photo',
              askForToken: true,
              appId: this.$accessor.appId,
              params: {
                add_to_news: 0,
                user_ids: this.$accessor.userId.toString(),
              },
              requestOptions: {
                url: 'StorySave',
                method: 'POST',
              },
            });
            this.bug.message = result ? JSON.stringify(result) : 'null';
            break;
          case this.bugsTypes.SlashMobileDownload:
            await this.testFileSlashDownload();
            break;
          case this.bugsTypes.Base64MobileDownload:
            await this.testFileBase64Download();
            break;
        }
      }
      catch (e) {
        this.bug.error = serializeError(e);
        console.error(e);
      }
      this.$emit('loading', false);
    },
    async testBugFix() {
      this.$emit('loading', true);
      try {
        const oldMessage = this.bug.message;
        const oldError = this.bug.error;
        delete this.bug.message;
        delete this.bug.error;

        switch (this.bug.type) {
          case this.bugsTypes.AndroidDownload :
            await this.testFileDownload();
            break;
          default:
            this.bug.message = oldMessage;
            this.bug.error = oldError;
            return;
        }
      }
      catch (e) {
        this.bug.error = serializeError(e);
        console.error(e);
      }
      this.$emit('loading', false);
    },
    async testStoryUpload() {
      await this.$wnm.vkGetToken(false, 'stories', this.$accessor.appId);
      const { upload_url } = await this.$wnm.vkCallApi('stories.getPhotoUploadServer', {
        user_ids: this.$accessor.userId,
      });
      const { result } = await this.$functions.request('StoryUpload', {
        method: 'POST',
        data: {
          server: upload_url,
        },
      });
      this.bug.message = result;
    },
    async testWallShare() {
      const { post_id } = await this.$connect.send('VKWebAppShowWallPostBox', {
        message: 'Only a test',
        publish_date: Math.floor(new Date(
          new Date().getFullYear(),
          new Date().getMonth(),
          new Date().getDate() + 30,
          new Date().getHours(),
          new Date().getMinutes(),
          new Date().getSeconds(),
        ).getTime() / 1000),
      });

      this.bug.message = typeof post_id;
    },
    async testFileDownload() {
      if (!this.$connect.supports('VKWebAppDownloadFile'))
        return this.bug.error = 'На вашем устройстве метод не поддерживается';

      const result = await this.$connect.send('VKWebAppDownloadFile', {
        url: 'https://vk-test-slashes.wnm.digital' + require('./../api/assets/story.png'),
        filename: 'test.png',
      });

      if (result.result) this.bug.message = 'Успех!';
      else this.bug.message = 'Файл не был загружен';
    },
    async testFileSlashDownload() {
      console.info(require('./../api/assets/story.png'));
      if (!this.$connect.supports('VKWebAppDownloadFile'))
        return this.bug.error = 'На вашем устройстве метод не поддерживается';

      const result = await this.$connect.send('VKWebAppDownloadFile', {
        url: require('./../api/assets/story.png'),
        filename: 'slash.png',
      });

      if (result.result) this.bug.message = 'Успех!';
      else this.bug.message = 'Файл не был загружен';
    },
    async testFileBase64Download() {
      if (!this.$connect.supports('VKWebAppDownloadFile'))
        return this.bug.error = 'На вашем устройстве метод не поддерживается';

      const result = await this.$connect.send('VKWebAppDownloadFile', {
        url: 'iVBORw0KGgoAAAANSUhEUgAAAAUAAAAFCAYAAACNbyblAAAAHElEQVQI12P4//8/w38GIAXDIBKE0DHxgljNBAAO9TXL0Y4OHwAAAABJRU5ErkJggg==',
        filename: 'base.png',
      });

      if (result.result) this.bug.message = 'Успех!';
      else this.bug.message = 'Файл не был загружен';
    },
  },
});
</script>

<style scoped>

</style>
